package nc.ui.om.post.action;

package ..deTemp.1731477351973;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import nc.ui.hr.uif2.action.SaveAction;
import nc.ui.om.post.model.PostModelDataManager;
import nc.ui.om.post.view.PostCardForm;
import nc.ui.uif2.IShowMsgConstant;
import nc.ui.uif2.ShowStatusBarMsgUtil;
import nc.ui.uif2.UIState;
import nc.vo.om.joblevelsys.LevelRelationVO;
import nc.vo.om.post.AggPostVO;
import nc.vo.pub.CircularlyAccessibleValueObject;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;

public class SavePostAction extends SaveAction {
  private static final long serialVersionUID = -8246609927679233550L;
  
  private PostModelDataManager dataManager = null;
  
  public void doAction(ActionEvent evt) throws Exception {
    Object objValue = getEditor().getValue();
    PostCardForm cardView = (PostCardForm)getEditor();
    if (!getModel().getUiState().equals(UIState.ADD)) {
      CircularlyAccessibleValueObject[] hisVOs = ((AggPostVO)getModel().getSelectedData()).getTableVO("om_posthistory");
      ((AggPostVO)objValue).setTableVO("om_posthistory", hisVOs);
    } 
    LevelRelationVO[] visibleLevelRankVOs = (LevelRelationVO[])cardView.getBillCardPanel().getBillModel("post_levelrelation").getBodyValueVOs(LevelRelationVO.class.getName());
    ArrayList<LevelRelationVO> allVOlist = new ArrayList<>();
    LevelRelationVO[] LevelRankVOs = (LevelRelationVO[])((AggPostVO)objValue).getTableVO("post_levelrelation");
    if (!ArrayUtils.isEmpty((Object[])LevelRankVOs))
      for (LevelRelationVO LevelRankVO : LevelRankVOs)
        allVOlist.add(LevelRankVO);  
    if (!ArrayUtils.isEmpty((Object[])visibleLevelRankVOs))
      for (LevelRelationVO visibleLevelRankVO : visibleLevelRankVOs) {
        if (0 == visibleLevelRankVO.getStatus())
          if (StringUtils.isNotBlank(visibleLevelRankVO.getPk_levelrelation())) {
            visibleLevelRankVO.setStatus(1);
            allVOlist.add(visibleLevelRankVO);
          }  
      }  
    ((AggPostVO)objValue).setTableVO("post_levelrelation", (CircularlyAccessibleValueObject[])allVOlist.toArray((Object[])new LevelRelationVO[0]));
    validate(objValue);
    Object returnObj = null;
    if (getModel().getUiState() == UIState.ADD) {
      returnObj = getModel().add(objValue);
    } else if (getModel().getUiState() == UIState.EDIT) {
      returnObj = getModel().update(objValue);
    } 
    getModel().setUiState(UIState.NOT_EDIT);
    ShowStatusBarMsgUtil.showStatusBarMsg(IShowMsgConstant.getSaveSuccessInfo(), getContext());
  }
  
  public PostModelDataManager getDataManager() {
    return this.dataManager;
  }
  
  public void setDataManager(PostModelDataManager dataManager) {
    this.dataManager = dataManager;
  }
}
